# MetaClass Class Reference
[MetaConfiguration's base classes]

List of all members.

## Public Member Functions

| __construct ($name)
| getName ()
| getTableName ()
| setTableName ($name)
| getType ()
| getTypeId ()
| setType (MetaClassType $type)
| getParent ()
| getFinalParent ()
| setParent (MetaClass $parent)
| hasBuildableParent ()
| getProperties ()
| getAllProperties ()
| with parent ones
| getWithInternalProperties ()
| with internal class' properties, if any
| getAllParentsProperties ()
| only parents
| addProperty (MetaClassProperty $property)
| getPropertyByName ($name)
| hasProperty ($name)
| dropProperty ($name)
| getInterfaces ()
| addInterface ($name)
| getPattern ()
| setPattern (GenerationPattern $pattern)
| getIdentifier ()
| setSourceLink ($link)
| getSourceLink ()
| setReferencingClass ($className)
| getReferencingClasses ()
| setFetchStrategy (FetchStrategy $strategy)
| getFetchStrategy ()
| getFetchStrategyId ()
| hasChilds ()
| dump ()
| doBuild ()
| setBuild ($do)
| isRedefinedProperty ($name)

## Private Attributes

| $name = null
| $tableName = null
| $type = null
| $parent = null
| $properties = array()
| $interfaces = array()
| $references = array()
| $pattern = null
| $identifier = null
| $source = null
| $strategy = null
| $build = true

## Detailed Description

Definition at line 15 of file MetaClass.class.php.

## Constructor & Destructor Documentation

MetaClass::__construct | ( | $ | name | ) |

Definition at line 36 of file MetaClass.class.php.

References $name.

## Member Function Documentation

MetaClass::addInterface | ( | $ | name | ) |

Returns:
  MetaClass

Definition at line 255 of file MetaClass.class.php.

References $name.

MetaClass::addProperty | ( | MetaClassProperty $ | property | ) |

Returns:
  MetaClass

Definition at line 193 of file MetaClass.class.php.

References $name, MetaClassProperty::getName(), and MetaClassProperty::isIdentifier().

Here is the call graph for this function:

MetaClass::doBuild | ( |  | ) |

Definition at line 369 of file MetaClass.class.php.

Referenced by dump().

MetaClass::dropProperty | ( | $ | name | ) |

Returns:
  MetaClass

Definition at line 230 of file MetaClass.class.php.

References $name.

MetaClass::dump | ( |  | ) |

Definition at line 361 of file MetaClass.class.php.

References doBuild().

Here is the call graph for this function:

MetaClass::getAllParentsProperties | ( |  | ) |

only parents

Definition at line 176 of file MetaClass.class.php.

References $parent.

MetaClass::getAllProperties | ( |  | ) |

with parent ones

Definition at line 142 of file MetaClass.class.php.

References getProperties().

Referenced by SchemaBuilder::buildRelations().

Here is the call graph for this function:

MetaClass::getFetchStrategy | ( |  | ) |

Returns:
  FetchStrategy

Definition at line 335 of file MetaClass.class.php.

MetaClass::getFetchStrategyId | ( |  | ) |

Definition at line 340 of file MetaClass.class.php.

MetaClass::getFinalParent | ( |  | ) |

Returns:
  MetaClass

Definition at line 107 of file MetaClass.class.php.

Referenced by BusinessClassBuilder::build(), and MetaConfiguration::checkSanity().

MetaClass::getIdentifier | ( |  | ) |

Returns:
  MetaClassProperty

Definition at line 283 of file MetaClass.class.php.

Referenced by BaseBuilder::buildPointers(), MetaConfiguration::checkSanity(), and AutoProtoClassBuilder::dumpMetaClass().

MetaClass::getInterfaces | ( |  | ) |

Definition at line 247 of file MetaClass.class.php.

MetaClass::getName | ( |  | ) |

Definition at line 50 of file MetaClass.class.php.

Referenced by ProtoClassBuilder::build(), EnumerationClassBuilder::build(), DictionaryDaoBuilder::build(), DaoBuilder::build(), BusinessClassBuilder::build(), AutoProtoClassBuilder::build(), BasePattern::buildBusiness(), ContainerClassBuilder::buildContainer(), BasePattern::buildDao(), BasePattern::buildProto(), SchemaBuilder::buildRelations(), MetaConfiguration::checkClassSanity(), MetaConfiguration::checkRecursion(), MetaConfiguration::checkSanity(), hasChilds(), ObjectType::toGetter(), and MetaClassProperty::toLightProperty().

MetaClass::getParent | ( |  | ) |

Returns:
  MetaClass

Definition at line 99 of file MetaClass.class.php.

Referenced by AutoProtoClassBuilder::build(), SchemaBuilder::buildRelations(), MetaConfiguration::checkSanity(), and hasBuildableParent().

MetaClass::getPattern | ( |  | ) |

Returns:
  GenerationPattern

Definition at line 265 of file MetaClass.class.php.

Referenced by BusinessClassBuilder::build(), BaseBuilder::buildPointers(), MetaConfiguration::checkClassSanity(), MetaConfiguration::checkSanity(), and hasBuildableParent().

MetaClass::getProperties | ( |  | ) |

Definition at line 136 of file MetaClass.class.php.

Referenced by MetaConfiguration::checkSanity(), getAllProperties(), and getWithInternalProperties().

MetaClass::getPropertyByName | ( | $ | name | ) |

Returns:
  MetaClassProperty

Exceptions:

  | MissingElementException |

Definition at line 214 of file MetaClass.class.php.

References $name.

MetaClass::getReferencingClasses | ( |  | ) |

Definition at line 317 of file MetaClass.class.php.

Referenced by BaseBuilder::buildPointers().

MetaClass::getSourceLink | ( |  | ) |

Definition at line 302 of file MetaClass.class.php.

Referenced by BaseBuilder::buildPointers().

MetaClass::getTableName | ( |  | ) |

Definition at line 55 of file MetaClass.class.php.

Referenced by SchemaBuilder::buildRelations().

MetaClass::getType | ( |  | ) |

Returns:
  MetaClassType

Definition at line 73 of file MetaClass.class.php.

Referenced by ProtoClassBuilder::build(), EnumerationClassBuilder::build(), DaoBuilder::build(), BusinessClassBuilder::build(), and MetaConfiguration::checkSanity().

MetaClass::getTypeId | ( |  | ) |

Definition at line 78 of file MetaClass.class.php.

Referenced by MetaConfiguration::checkClassSanity(), and MetaConfiguration::checkSanity().

MetaClass::getWithInternalProperties | ( |  | ) |

with internal class' properties, if any

Definition at line 154 of file MetaClass.class.php.

References $parent, and getProperties().

Referenced by BaseBuilder::buildPointers(), and AutoProtoClassBuilder::dumpMetaClass().

Here is the call graph for this function:

MetaClass::hasBuildableParent | ( |  | ) |

Definition at line 125 of file MetaClass.class.php.

References getParent(), and getPattern().

Referenced by AutoProtoClassBuilder::build(), and AutoProtoClassBuilder::dumpMetaClass().

Here is the call graph for this function:

MetaClass::hasChilds | ( |  | ) |

Definition at line 348 of file MetaClass.class.php.

References getName(), and MetaConfiguration::me().

Here is the call graph for this function:

MetaClass::hasProperty | ( | $ | name | ) |

Definition at line 222 of file MetaClass.class.php.

References $name.

MetaClass::isRedefinedProperty | ( | $ | name | ) |

Returns:
  MetaClassProperty

Definition at line 387 of file MetaClass.class.php.

References $name, and $parent.

MetaClass::setBuild | ( | $ | do | ) |

Returns:
  MetaClass

Definition at line 377 of file MetaClass.class.php.

MetaClass::setFetchStrategy | ( | FetchStrategy $ | strategy | ) |

Returns:
  MetaClass

Definition at line 325 of file MetaClass.class.php.

MetaClass::setParent | ( | MetaClass $ | parent | ) |

Returns:
  MetaClass

Definition at line 118 of file MetaClass.class.php.

MetaClass::setPattern | ( | GenerationPattern $ | pattern | ) |

Returns:
  MetaClass

Definition at line 273 of file MetaClass.class.php.

MetaClass::setReferencingClass | ( | $ | className | ) |

Returns:
  MetaClass

Definition at line 310 of file MetaClass.class.php.

MetaClass::setSourceLink | ( | $ | link | ) |

Returns:
  MetaClass

Definition at line 295 of file MetaClass.class.php.

MetaClass::setTableName | ( | $ | name | ) |

Returns:
  MetaClass

Definition at line 63 of file MetaClass.class.php.

References $name.

MetaClass::setType | ( | MetaClassType $ | type | ) |

Returns:
  MetaClass

Definition at line 89 of file MetaClass.class.php.

## Member Data Documentation

MetaClass::$build = true`[private]`

Definition at line 34 of file MetaClass.class.php.

MetaClass::$identifier = null`[private]`

Definition at line 28 of file MetaClass.class.php.

MetaClass::$interfaces = array()`[private]`

Definition at line 24 of file MetaClass.class.php.

MetaClass::$name = null`[private]`

Definition at line 17 of file MetaClass.class.php.

Referenced by __construct(), addInterface(), addProperty(), dropProperty(), getPropertyByName(), hasProperty(), isRedefinedProperty(), and setTableName().

MetaClass::$parent = null`[private]`

Definition at line 21 of file MetaClass.class.php.

Referenced by getAllParentsProperties(), getWithInternalProperties(), and isRedefinedProperty().

MetaClass::$pattern = null`[private]`

Definition at line 27 of file MetaClass.class.php.

MetaClass::$properties = array()`[private]`

Definition at line 23 of file MetaClass.class.php.

MetaClass::$references = array()`[private]`

Definition at line 25 of file MetaClass.class.php.

MetaClass::$source = null`[private]`

Definition at line 30 of file MetaClass.class.php.

MetaClass::$strategy = null`[private]`

Definition at line 32 of file MetaClass.class.php.

MetaClass::$tableName = null`[private]`

Definition at line 18 of file MetaClass.class.php.

MetaClass::$type = null`[private]`

Definition at line 19 of file MetaClass.class.php.

The documentation for this class was generated from the following file:

- meta/classes/MetaClass.class.php